# mypy-boto3-alexaforbusiness

[![PyPI - mypy-boto3-alexaforbusiness](https://img.shields.io/pypi/v/mypy-boto3-alexaforbusiness.svg?color=blue)](https://pypi.org/project/mypy-boto3-alexaforbusiness)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-alexaforbusiness.svg?color=blue)](https://pypi.org/project/mypy-boto3-alexaforbusiness)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

Type annotations for
[boto3.AlexaForBusiness 1.14.10](https://boto3.amazonaws.com/v1/documentation/api/1.14.10/reference/services/alexaforbusiness.html#AlexaForBusiness) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.2.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

## How to install

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `AlexaForBusiness` service.

```bash
python -m pip install boto3-stubs[alexaforbusiness]
```

## How to use

### Client annotations

`AlexaForBusinessClient` provides annotations for `boto3.client("alexaforbusiness")`.

```python
import boto3

from mypy_boto3_alexaforbusiness import AlexaForBusinessClient
from mypy_boto3_alexaforbusiness.paginator import (
    ListBusinessReportSchedulesPaginator,
    ListConferenceProvidersPaginator,
    ListDeviceEventsPaginator,
    ListSkillsPaginator,
    ListSkillsStoreCategoriesPaginator,
    ListSkillsStoreSkillsByCategoryPaginator,
    ListSmartHomeAppliancesPaginator,
    ListTagsPaginator,
    SearchDevicesPaginator,
    SearchProfilesPaginator,
    SearchRoomsPaginator,
    SearchSkillGroupsPaginator,
    SearchUsersPaginator,
)
from mypy_boto3_alexaforbusiness.type_defs import AddressBookDataTypeDef, ...

client: AlexaForBusinessClient = boto3.client("alexaforbusiness")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: AlexaForBusinessClient = session.client("alexaforbusiness")
```

### Paginators annotations

`mypy_boto3_alexaforbusiness.paginator` module contains type annotations for all paginators.

```python

client: AlexaForBusinessClient = boto3.client("alexaforbusiness")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
list_business_report_schedules_paginator: ListBusinessReportSchedulesPaginator = client.get_paginator("list_business_report_schedules")
list_conference_providers_paginator: ListConferenceProvidersPaginator = client.get_paginator("list_conference_providers")
list_device_events_paginator: ListDeviceEventsPaginator = client.get_paginator("list_device_events")
list_skills_paginator: ListSkillsPaginator = client.get_paginator("list_skills")
list_skills_store_categories_paginator: ListSkillsStoreCategoriesPaginator = client.get_paginator("list_skills_store_categories")
list_skills_store_skills_by_category_paginator: ListSkillsStoreSkillsByCategoryPaginator = client.get_paginator("list_skills_store_skills_by_category")
list_smart_home_appliances_paginator: ListSmartHomeAppliancesPaginator = client.get_paginator("list_smart_home_appliances")
list_tags_paginator: ListTagsPaginator = client.get_paginator("list_tags")
search_devices_paginator: SearchDevicesPaginator = client.get_paginator("search_devices")
search_profiles_paginator: SearchProfilesPaginator = client.get_paginator("search_profiles")
search_rooms_paginator: SearchRoomsPaginator = client.get_paginator("search_rooms")
search_skill_groups_paginator: SearchSkillGroupsPaginator = client.get_paginator("search_skill_groups")
search_users_paginator: SearchUsersPaginator = client.get_paginator("search_users")
```







### Typed dictionations

`mypy_boto3_alexaforbusiness.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python

def get_structure() -> AddressBookDataTypeDef:
    return {
      ...
    }
```


## Dynamic type annotations

`mypy_boto3` command generates `boto3.client/resource` type annotations for
`mypy_boto3_alexaforbusiness` and other installed services.

```bash
# Run this command after you add or remove service packages
python -m mypy_boto3
```

Generated type annotations provide overloads for `boto3.client` and `boto3.resource`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully if you have many services installed
- `VSCode` does not currently support function overloads, use explicit type annotations

```python

# Type is discovered correctly by mypy and PyCharm
# VSCode still needs explicit type annotations
client = boto3.client("alexaforbusiness")

session_client = boto3.Session().client("alexaforbusiness")
```
